package main

import (
	"fmt"
	"sync"
	"runtime"
)

// Задача №1
// 1. Создать две горутины
// 2. Буферизованный канал
// 3. используя пакет waitGroup{} показать ожидание завершения обеих

func main() {
	example1()
	//example2()
	//example3()
}

func example1() {
	runtime.GOMAXPROCS(1)
	i := 0
	wg := sync.WaitGroup{}
	wg.Add(2)
	go func() {
		defer wg.Done()
		i++
	}()

	go func() {
		defer wg.Done()
		i++
	}()

	wg.Wait()
	fmt.Println(i)
}

func example2() {
	i := 0
	ch := make(chan struct{})
	go func() {
		i = 1
		<-ch
	}()

	// Если канал пустой, то горутина-получатель блокируется,
	// пока в канале не окажутся данные.
	// Когда горутина-отправитель посылает данные, горутина-получатель
	// получает эти данные и возобновляет работу.

	// Горутина-отправитель может отправлять данные только в пустой канал.
	// Горутина-отправитель блокируется до тех пор, пока данные из канала
	// не будут получены
	ch <- struct{}{}
	fmt.Println(i)
}
func example3() {
	i := 0
	ch := make(chan struct{}, 1)
	go func() {
		i = 1
		<-ch
	}()

	//Этот код приводит к возникновению гонки данных.
	//Чтение и запись в i могут происходить одновременно; следовательно,
	//i не синхронизирован.
	ch <- struct{}{}
	fmt.Println(i)
}
